diff --git a/tests/form_pages/test_all.py b/tests/form_pages/test_all.py
index 93743c523..041f0e358 100644
--- a/tests/form_pages/test_all.py
+++ b/tests/form_pages/test_all.py
@@ -1,12 +1,15 @@
 # -*- coding: utf-8 -*-
 
+import io
 import json
 import pytest
 import hashlib
 import os
 import re
 import time
+import urllib.parse
 import zipfile
+
 from webtest import Upload, Hidden, Radio
 import mock
 import xml.etree.ElementTree as ET
@@ -16,9 +19,6 @@ try:
 except ImportError:
     Image = None
 
-from django.utils.six import StringIO, BytesIO
-from django.utils.six.moves.urllib import parse as urlparse
-
 from django.utils.encoding import force_bytes, force_text
 
 from wcs.qommon import force_str
@@ -2627,7 +2627,7 @@ def test_form_edit_autocomplete_list(pub):
                 {'id': '2', 'text': 'world', 'extra': 'bar'},
             ]
         }
-        urlopen.side_effect = lambda *args: StringIO(json.dumps(data))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps(data))
         resp = app.get('/test/')
         assert 'data-select2-url=' in resp.text
         # simulate select2 mode, with qommon.forms.js adding an extra hidden widget
@@ -2771,13 +2771,13 @@ def test_form_item_data_source_field_submit(pub):
 
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
         data = {'data': [{'id': '1', 'text': 'un'}, {'id': '2', 'text': 'deux'}]}
-        urlopen.side_effect = lambda *args: StringIO(json.dumps(data))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps(data))
         assert submit_item_data_source_field(ds) == {'0': '1', '0_display': 'un'}
 
     # numeric identifiers
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
         data = {'data': [{'id': 1, 'text': 'un'}, {'id': 2, 'text': 'deux'}]}
-        urlopen.side_effect = lambda *args: StringIO(json.dumps(data))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps(data))
         assert submit_item_data_source_field(ds) == {'0': '1', '0_display': 'un'}
 
 
@@ -2954,7 +2954,7 @@ def test_form_page_session_var_prefill(pub):
 
     # check it's not set if it's not whitelisted
     resp = get_app(pub).get('/?session_var_foo=hello')
-    assert urlparse.urlparse(resp.location).path == '/'
+    assert urllib.parse.urlparse(resp.location).path == '/'
     resp = resp.follow()
     resp = resp.click('test')
     assert resp.forms[0]['f0'].value == ''
@@ -2967,14 +2967,14 @@ query_string_allowed_vars = foo,bar
     )
 
     resp = get_app(pub).get('/?session_var_foo=hello')
-    assert urlparse.urlparse(resp.location).path == '/'
+    assert urllib.parse.urlparse(resp.location).path == '/'
     resp = resp.follow()
     resp = resp.click('test')
     assert resp.forms[0]['f0'].value == 'hello'
 
     # check it survives a login
     resp = get_app(pub).get('/?session_var_foo=hello2')
-    assert urlparse.urlparse(resp.location).path == '/'
+    assert urllib.parse.urlparse(resp.location).path == '/'
     resp = resp.follow()
     resp = resp.click('Login')
     resp = resp.follow()
@@ -2987,15 +2987,15 @@ query_string_allowed_vars = foo,bar
 
     # check repeated options are ignored
     resp = get_app(pub).get('/?session_var_foo=hello&session_var_foo=hello2')
-    assert urlparse.urlparse(resp.location).path == '/'
+    assert urllib.parse.urlparse(resp.location).path == '/'
     resp = resp.follow()
     resp = resp.click('test')
     assert resp.forms[0]['f0'].value == ''
 
     # check extra query string parameters are not lost
     resp = get_app(pub).get('/?session_var_foo=hello&foo=bar')
-    assert urlparse.urlparse(resp.location).path == '/'
-    assert urlparse.urlparse(resp.location).query == 'foo=bar'
+    assert urllib.parse.urlparse(resp.location).path == '/'
+    assert urllib.parse.urlparse(resp.location).query == 'foo=bar'
 
     os.unlink(os.path.join(pub.app_dir, 'site-options.cfg'))
 
@@ -3156,7 +3156,7 @@ def test_form_page_formula_prefill_items_field(pub):
 
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
         data = {'data': [{'id': '1', 'text': 'hello'}, {'id': '2', 'text': 'world'}]}
-        urlopen.side_effect = lambda *args: StringIO(json.dumps(data))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps(data))
         resp = get_app(pub).get('/test/')
         assert not resp.form['f0$element1'].checked
         assert resp.form['f0$element2'].checked
@@ -3358,7 +3358,7 @@ def test_form_file_field_with_fargo(pub, fargo_url):
     fargo_resp = app.get('/fargo/pick')  # display file picker
     assert fargo_resp.location == 'http://fargo.example.net/pick/?pick=http%3A//example.net/fargo/pick'
     with mock.patch('wcs.portfolio.urlopen') as urlopen:
-        urlopen.side_effect = lambda *args: BytesIO(b'...')
+        urlopen.side_effect = lambda *args: io.BytesIO(b'...')
         fargo_resp = app.get('/fargo/pick?url=http://www.example.org/...')
         assert 'window.top.document.fargo_set_token' in fargo_resp.text
     resp.form['f0$file'] = None
@@ -5511,7 +5511,7 @@ def test_item_field_with_disabled_items(http_requests, pub):
 
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
         data = {'data': [{'id': '1', 'text': 'hello'}, {'id': '2', 'text': 'world'}]}
-        urlopen.side_effect = lambda *args: StringIO(json.dumps(data))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps(data))
         resp = get_app(pub).get('/test/')
         resp.form['f0'] = '1'
         resp.form['f0'] = '2'
@@ -5524,7 +5524,7 @@ def test_item_field_with_disabled_items(http_requests, pub):
 
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
         data = {'data': [{'id': '1', 'text': 'hello', 'disabled': True}, {'id': '2', 'text': 'world'}]}
-        urlopen.side_effect = lambda *args: StringIO(json.dumps(data))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps(data))
         resp = get_app(pub).get('/test/')
         pq = resp.pyquery.remove_namespaces()
         assert pq('option[disabled=disabled][value="1"]').text() == 'hello'
@@ -5550,7 +5550,7 @@ def test_item_field_with_disabled_items(http_requests, pub):
 
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
         data = {'data': [{'id': '1', 'text': 'hello', 'disabled': True}, {'id': '2', 'text': 'world'}]}
-        urlopen.side_effect = lambda *args: StringIO(json.dumps(data))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps(data))
         resp = get_app(pub).get('/test/')
         pq = resp.pyquery.remove_namespaces()
         assert len(pq('option[disabled=disabled][value="1"]')) == 0
@@ -5575,7 +5575,7 @@ def test_item_field_with_disabled_items(http_requests, pub):
 
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
         data = {'data': [{'id': '1', 'text': 'hello'}, {'id': '2', 'text': 'world'}]}
-        urlopen.side_effect = lambda *args: StringIO(json.dumps(data))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps(data))
         resp = get_app(pub).get('/test/')
         resp.form['f0'] = '1'
         resp.form['f0'] = '2'
@@ -5588,7 +5588,7 @@ def test_item_field_with_disabled_items(http_requests, pub):
 
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
         data = {'data': [{'id': '1', 'text': 'hello', 'disabled': True}, {'id': '2', 'text': 'world'}]}
-        urlopen.side_effect = lambda *args: StringIO(json.dumps(data))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps(data))
         resp = get_app(pub).get('/test/')
         pq = resp.pyquery.remove_namespaces()
         assert len(pq('input[name="f0"][disabled=disabled][value="1"]')) == 1
@@ -5619,7 +5619,7 @@ def test_items_field_with_disabled_items(http_requests, pub):
 
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
         data = {'data': [{'id': '1', 'text': 'hello'}, {'id': '2', 'text': 'world'}]}
-        urlopen.side_effect = lambda *args: StringIO(json.dumps(data))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps(data))
         resp = get_app(pub).get('/test/')
         resp.form['f0$element1'].checked = True
         resp.form['f0$element2'].checked = True
@@ -5632,7 +5632,7 @@ def test_items_field_with_disabled_items(http_requests, pub):
 
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
         data = {'data': [{'id': '1', 'text': 'hello', 'disabled': True}, {'id': '2', 'text': 'world'}]}
-        urlopen.side_effect = lambda *args: StringIO(json.dumps(data))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps(data))
         resp = get_app(pub).get('/test/')
         assert 'disabled' in resp.form['f0$element1'].attrs
         resp.form['f0$element1'].checked = True
@@ -5650,7 +5650,7 @@ def test_items_field_with_disabled_items(http_requests, pub):
 
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
         data = {'data': [{'id': '1', 'text': 'hello', 'disabled': True}, {'id': '2', 'text': 'world'}]}
-        urlopen.side_effect = lambda *args: StringIO(json.dumps(data))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps(data))
         resp = get_app(pub).get('/test/')
         assert not 'f0$element1' in resp.form.fields
         resp.form['f0$element2'].checked = True
@@ -5688,7 +5688,7 @@ def test_item_field_autocomplete_json_source(http_requests, pub):
                 {'id': '2', 'text': 'world', 'extra': 'bar'},
             ]
         }
-        urlopen.side_effect = lambda *args: StringIO(json.dumps(data))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps(data))
         resp = get_app(pub).get('/test/')
         assert 'data-autocomplete="true"' in resp.text
         assert resp.form['f0'].value == '1'
@@ -5709,7 +5709,7 @@ def test_item_field_autocomplete_json_source(http_requests, pub):
                 {'id': '2', 'text': 'world', 'extra': 'bar'},
             ]
         }
-        urlopen.side_effect = lambda *args: StringIO(json.dumps(data))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps(data))
         resp = get_app(pub).get('/test/')
         assert 'data-autocomplete="true"' in resp.text
         assert 'data-hint="help text"' in resp.text
@@ -5733,7 +5733,7 @@ def test_item_field_autocomplete_json_source(http_requests, pub):
                 {'id': '2', 'text': 'world', 'extra': 'bar'},
             ]
         }
-        urlopen.side_effect = lambda *args: StringIO(json.dumps(data))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps(data))
         resp = app.get('/test/')
         assert urlopen.call_count == 0
         pq = resp.pyquery.remove_namespaces()
@@ -5741,7 +5741,7 @@ def test_item_field_autocomplete_json_source(http_requests, pub):
 
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
         data = {'data': [{'id': '1', 'text': 'hello', 'extra': 'foo'}]}
-        urlopen.side_effect = lambda *args: StringIO(json.dumps(data))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps(data))
         resp2 = app.get(select2_url + '?q=hell')
         assert urlopen.call_count == 1
         assert urlopen.call_args[0][0] == 'http://remote.example.net/json?q=hell'
@@ -5757,7 +5757,7 @@ def test_item_field_autocomplete_json_source(http_requests, pub):
 
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
         data = {'data': [{'id': '1', 'text': 'hello', 'extra': 'foo'}]}
-        urlopen.side_effect = lambda *args: StringIO(json.dumps(data))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps(data))
         resp = resp.form.submit('submit')  # -> validation page
         assert urlopen.call_count == 1
         assert urlopen.call_args[0][0] == 'http://remote.example.net/json?id=1'
@@ -5766,7 +5766,7 @@ def test_item_field_autocomplete_json_source(http_requests, pub):
 
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
         data = {'data': [{'id': '1', 'text': 'hello', 'extra': 'foo'}]}
-        urlopen.side_effect = lambda *args: StringIO(json.dumps(data))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps(data))
         resp = resp.form.submit('submit')  # -> submit
         assert urlopen.call_count == 1
         assert urlopen.call_args[0][0] == 'http://remote.example.net/json?id=1'
@@ -5784,7 +5784,7 @@ def test_item_field_autocomplete_json_source(http_requests, pub):
         data = {
             'data': [{'id': 1, 'text': 'hello', 'extra': 'foo'}, {'id': 2, 'text': 'world', 'extra': 'bar'}]
         }
-        urlopen.side_effect = lambda *args: StringIO(json.dumps(data))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps(data))
         resp = app.get('/test/')
         assert urlopen.call_count == 0
         pq = resp.pyquery.remove_namespaces()
@@ -5792,7 +5792,7 @@ def test_item_field_autocomplete_json_source(http_requests, pub):
 
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
         data = {'data': [{'id': 1, 'text': 'hello', 'extra': 'foo'}]}
-        urlopen.side_effect = lambda *args: StringIO(json.dumps(data))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps(data))
         resp2 = app.get(select2_url + '?q=hell')
         assert urlopen.call_count == 1
         assert urlopen.call_args[0][0] == 'http://remote.example.net/json-numeric-id?q=hell'
@@ -5808,7 +5808,7 @@ def test_item_field_autocomplete_json_source(http_requests, pub):
 
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
         data = {'data': [{'id': 1, 'text': 'hello', 'extra': 'foo'}]}
-        urlopen.side_effect = lambda *args: StringIO(json.dumps(data))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps(data))
         resp = resp.form.submit('submit')  # -> validation page
         assert urlopen.call_count == 1
         assert urlopen.call_args[0][0] == 'http://remote.example.net/json-numeric-id?id=1'
@@ -5817,7 +5817,7 @@ def test_item_field_autocomplete_json_source(http_requests, pub):
 
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
         data = {'data': [{'id': 1, 'text': 'hello', 'extra': 'foo'}]}
-        urlopen.side_effect = lambda *args: StringIO(json.dumps(data))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps(data))
         resp = resp.form.submit('submit')  # -> submit
         assert urlopen.call_count == 1
         assert urlopen.call_args[0][0] == 'http://remote.example.net/json-numeric-id?id=1'
@@ -5844,7 +5844,7 @@ remote.example.net = 1234
                 {'id': '2', 'text': 'world', 'extra': 'bar'},
             ]
         }
-        urlopen.side_effect = lambda *args: StringIO(json.dumps(data))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps(data))
         resp = app.get('/test/')
         assert urlopen.call_count == 0
         pq = resp.pyquery.remove_namespaces()
@@ -5852,7 +5852,7 @@ remote.example.net = 1234
 
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
         data = {'data': [{'id': '1', 'text': 'hello', 'extra': 'foo'}]}
-        urlopen.side_effect = lambda *args: StringIO(json.dumps(data))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps(data))
         resp2 = app.get(select2_url + '?q=hell')
         assert urlopen.call_count == 1
         assert urlopen.call_args[0][0].startswith('http://remote.example.net/json?q=hell&orig=example.net&')
@@ -5865,7 +5865,7 @@ remote.example.net = 1234
 
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
         data = {'data': [{'id': '1', 'text': 'hello', 'extra': 'foo'}]}
-        urlopen.side_effect = lambda *args: StringIO(json.dumps(data))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps(data))
         resp = resp.form.submit('submit')  # -> validation page
         assert urlopen.call_count == 1
         assert urlopen.call_args[0][0].startswith('http://remote.example.net/json?id=1&orig=example.net&')
@@ -5874,7 +5874,7 @@ remote.example.net = 1234
 
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
         data = {'data': [{'id': '1', 'text': 'hello', 'extra': 'foo'}]}
-        urlopen.side_effect = lambda *args: StringIO(json.dumps(data))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps(data))
         resp = resp.form.submit('submit')  # -> submit
         assert urlopen.call_count == 1
         assert urlopen.call_args[0][0].startswith('http://remote.example.net/json?id=1&orig=example.net&')
@@ -5895,7 +5895,7 @@ remote.example.net = 1234
                 {'id': '2', 'text': 'world', 'extra': 'bar'},
             ]
         }
-        urlopen.side_effect = lambda *args: StringIO(json.dumps(data))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps(data))
         resp = app.get('/test/')
         pq = resp.pyquery.remove_namespaces()
         select2_url = pq('select').attr['data-select2-url']
@@ -5919,7 +5919,7 @@ remote.example.net = 1234
                 {'id': '2', 'text': 'world', 'extra': 'bar'},
             ]
         }
-        urlopen.side_effect = lambda *args: StringIO(json.dumps(data))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps(data))
         resp = app.get('/test/')
         assert urlopen.call_count == 0
         pq = resp.pyquery.remove_namespaces()
@@ -5927,7 +5927,7 @@ remote.example.net = 1234
 
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
         data = {'data': [{'id': '1', 'text': 'hello', 'extra': 'foo'}]}
-        urlopen.side_effect = lambda *args: StringIO(json.dumps(data))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps(data))
         resp2 = app.get(select2_url + '?q=hell', status=403)
         assert urlopen.call_count == 0
 
@@ -8332,7 +8332,7 @@ def test_create_formdata_empty_item_ds_with_id_parameter(pub, create_formdata):
 
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
         data = {'data': create_formdata['data']}
-        urlopen.side_effect = lambda *args: StringIO(json.dumps(data))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps(data))
 
         app = get_app(create_formdata['pub'])
         resp = app.get('/source-form/')
@@ -8710,7 +8710,7 @@ def test_form_item_timetable_data_source(pub, http_requests):
                 {"id": "3", "datetime": "2021-01-14 10:40:00", "text": "event 3"},
             ]
         }
-        urlopen.side_effect = lambda *args: StringIO(json.dumps(data))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps(data))
 
         resp = app.get('/test/')
         assert 'data-date="2021-01-12"' in resp and 'data-time="10:00"' in resp
@@ -8764,7 +8764,7 @@ def test_form_item_timetable_data_source_with_date_alignment(pub, http_requests)
                 {"id": "3", "datetime": "2021-01-14 10:40:00", "text": "event 3"},
             ]
         }
-        urlopen.side_effect = lambda *args: StringIO(json.dumps(data))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps(data))
 
         resp = app.get('/test/')
         resp.form['f2'] = '2021-01-14'
diff --git a/tests/form_pages/test_block.py b/tests/form_pages/test_block.py
index 735ae4536..cd8e2de68 100644
--- a/tests/form_pages/test_block.py
+++ b/tests/form_pages/test_block.py
@@ -1,9 +1,9 @@
 # -*- coding: utf-8 -*-
+
+import io
 import json
 import mock
 
-from django.utils.six import StringIO
-
 import pytest
 from webtest import Upload
 
@@ -1255,7 +1255,7 @@ def test_block_with_dynamic_item_field(mock_urlopen, pub, blocks_feature):
             payload = [{'id': '1', 'text': 'foo'}]
         elif query == 'bar':
             payload = [{'id': '2', 'text': 'bar'}]
-        return StringIO(json.dumps({'data': payload}))
+        return io.StringIO(json.dumps({'data': payload}))
 
     mock_urlopen.side_effect = lambda url: data_source(url)
 
diff --git a/tests/form_pages/test_formdata.py b/tests/form_pages/test_formdata.py
index b094258ef..f813b3dd7 100644
--- a/tests/form_pages/test_formdata.py
+++ b/tests/form_pages/test_formdata.py
@@ -1,5 +1,7 @@
 # -*- coding: utf-8 -*-
+
 import base64
+import io
 import json
 import locale
 import os
@@ -9,8 +11,7 @@ import zipfile
 import mock
 import pytest
 from django.utils.encoding import force_bytes
-from django.utils.six import BytesIO, StringIO
-from django.utils.six.moves.urllib import parse as urlparse
+import urllib.parse
 from quixote.http_request import Upload as QuixoteUpload
 from webtest import Upload, Hidden
 
@@ -332,7 +333,7 @@ def test_formdata_generated_document_download(pub):
     export_to.convert_to_pdf = False
     export_to.label = 'create doc'
     upload = QuixoteUpload('/foo/test.rtf', content_type='application/rtf')
-    upload.fp = BytesIO()
+    upload.fp = io.BytesIO()
     upload.fp.write(b'HELLO WORLD')
     upload.fp.seek(0)
     export_to.model_file = UploadedFile(pub.app_dir, None, upload)
@@ -382,7 +383,7 @@ def test_formdata_generated_document_download(pub):
     # change export model to now be a RTF file, do the action again on the same form and
     # check that both the old .odt file and the new .rtf file are there and valid.
     upload = QuixoteUpload('/foo/test.rtf', content_type='application/rtf')
-    upload.fp = BytesIO()
+    upload.fp = io.BytesIO()
     upload.fp.write(b'HELLO NEW WORLD')
     upload.fp.seek(0)
     export_to.model_file = UploadedFile(pub.app_dir, None, upload)
@@ -398,7 +399,7 @@ def test_formdata_generated_document_download(pub):
 
     # use substitution variables on rtf: only ezt format is accepted
     upload = QuixoteUpload('/foo/test.rtf', content_type='application/rtf')
-    upload.fp = BytesIO()
+    upload.fp = io.BytesIO()
     upload.fp.write(b'HELLO {{DJANGO}} WORLD [form_name]')
     upload.fp.seek(0)
     export_to.model_file = UploadedFile(pub.app_dir, None, upload)
@@ -427,7 +428,7 @@ def test_formdata_generated_document_odt_download(pub, odt_template):
     template_filename = os.path.join(os.path.dirname(__file__), '..', odt_template)
     template = open(template_filename, 'rb').read()
     upload = QuixoteUpload('/foo/' + odt_template, content_type='application/octet-stream')
-    upload.fp = BytesIO()
+    upload.fp = io.BytesIO()
     upload.fp.write(template)
     upload.fp.seek(0)
     export_to.model_file = UploadedFile(pub.app_dir, None, upload)
@@ -460,7 +461,7 @@ def test_formdata_generated_document_odt_download(pub, odt_template):
     resp = resp.follow()  # $form/$id/create_doc
     resp = resp.follow()  # $form/$id/create_doc/
     with open(os.path.join(os.path.dirname(__file__), '..', 'template-out.odt'), 'rb') as f:
-        assert_equal_zip(BytesIO(resp.body), f)
+        assert_equal_zip(io.BytesIO(resp.body), f)
 
     resp = login(get_app(pub), username='foo', password='foo').get(form_location)
     resp = resp.form.submit('button_export_to')
@@ -487,11 +488,11 @@ def test_formdata_generated_document_odt_download(pub, odt_template):
     resp = resp.follow()
     assert resp.content_type == 'application/octet-stream'
     with open(os.path.join(os.path.dirname(__file__), '..', 'template-out.odt'), 'rb') as f:
-        assert_equal_zip(BytesIO(resp.body), f)
+        assert_equal_zip(io.BytesIO(resp.body), f)
 
     # change file content, same name
     upload = QuixoteUpload('/foo/test.rtf', content_type='application/rtf')
-    upload.fp = BytesIO()
+    upload.fp = io.BytesIO()
     upload.fp.write(b'HELLO NEW WORLD')
     upload.fp.seek(0)
     export_to.model_file = UploadedFile(pub.app_dir, None, upload)
@@ -504,7 +505,7 @@ def test_formdata_generated_document_odt_download(pub, odt_template):
 
     with open(os.path.join(os.path.dirname(__file__), '..', 'template-out.odt'), 'rb') as f:
         body = resp.click(odt_template, index=0).follow().body
-        assert_equal_zip(BytesIO(body), f)
+        assert_equal_zip(io.BytesIO(body), f)
     assert resp.click('test.rtf', index=0).follow().body == b'HELLO NEW WORLD'
 
 
@@ -519,7 +520,7 @@ def test_formdata_generated_document_odt_download_with_substitution_variable(pub
     template_filename = os.path.join(os.path.dirname(__file__), '..', 'template.odt')
     template = open(template_filename, 'rb').read()
     upload = QuixoteUpload('/foo/template.odt', content_type='application/octet-stream')
-    upload.fp = BytesIO()
+    upload.fp = io.BytesIO()
     upload.fp.write(template)
     upload.fp.seek(0)
     export_to.model_file = UploadedFile(pub.app_dir, None, upload)
@@ -552,7 +553,7 @@ def test_formdata_generated_document_odt_download_with_substitution_variable(pub
     resp = resp.follow()  # $form/$id/create_doc
     resp = resp.follow()  # $form/$id/create_doc/
     with open(os.path.join(os.path.dirname(__file__), '..', 'template-out.odt'), 'rb') as f:
-        assert_equal_zip(BytesIO(resp.body), f)
+        assert_equal_zip(io.BytesIO(resp.body), f)
 
     export_to.attach_to_history = True
     wf.store()
@@ -567,11 +568,11 @@ def test_formdata_generated_document_odt_download_with_substitution_variable(pub
     response1 = resp = resp.follow()
     assert resp.content_type == 'application/octet-stream'
     with open(os.path.join(os.path.dirname(__file__), '..', 'template-out.odt'), 'rb') as f:
-        assert_equal_zip(BytesIO(resp.body), f)
+        assert_equal_zip(io.BytesIO(resp.body), f)
 
     # change file content, same name
     upload = QuixoteUpload('/foo/test.rtf', content_type='application/rtf')
-    upload.fp = BytesIO()
+    upload.fp = io.BytesIO()
     upload.fp.write(b'HELLO NEW WORLD')
     upload.fp.seek(0)
     export_to.model_file = UploadedFile(pub.app_dir, None, upload)
@@ -584,7 +585,7 @@ def test_formdata_generated_document_odt_download_with_substitution_variable(pub
 
     with open(os.path.join(os.path.dirname(__file__), '..', 'template-out.odt'), 'rb') as f:
         body = resp.click('template.odt', index=0).follow().body
-        assert_equal_zip(BytesIO(body), f)
+        assert_equal_zip(io.BytesIO(body), f)
     response2 = resp.click('test.rtf', index=0).follow()
     assert response2.body == b'HELLO NEW WORLD'
     # Test attachment substitution variables
@@ -640,7 +641,7 @@ def test_formdata_generated_document_odt_to_pdf_download(pub):
     template_filename = os.path.join(os.path.dirname(__file__), '..', 'template.odt')
     template = open(template_filename, 'rb').read()
     upload = QuixoteUpload('/foo/template.odt', content_type='application/octet-stream')
-    upload.fp = BytesIO()
+    upload.fp = io.BytesIO()
     upload.fp.write(template)
     upload.fp.seek(0)
     export_to.model_file = UploadedFile(pub.app_dir, None, upload)
@@ -711,7 +712,7 @@ def test_formdata_generated_document_odt_to_pdf_download_push_to_portfolio(
     template_filename = os.path.join(os.path.dirname(__file__), '..', 'template.odt')
     template = open(template_filename, 'rb').read()
     upload = QuixoteUpload('/foo/template.odt', content_type='application/octet-stream')
-    upload.fp = BytesIO()
+    upload.fp = io.BytesIO()
     upload.fp.write(template)
     upload.fp.seek(0)
     export_to.model_file = UploadedFile(pub.app_dir, None, upload)
@@ -804,7 +805,7 @@ def test_formdata_generated_document_non_interactive(pub):
     template_filename = os.path.join(os.path.dirname(__file__), '..', 'template.odt')
     template = open(template_filename, 'rb').read()
     upload = QuixoteUpload('/foo/template.odt', content_type='application/octet-stream')
-    upload.fp = BytesIO()
+    upload.fp = io.BytesIO()
     upload.fp.write(template)
     upload.fp.seek(0)
     export_to.model_file = UploadedFile(pub.app_dir, None, upload)
@@ -844,7 +845,7 @@ def test_formdata_generated_document_non_interactive(pub):
     resp = resp.follow()
     assert resp.content_type == 'application/octet-stream'
     with open(os.path.join(os.path.dirname(__file__), '..', 'template-out.odt'), 'rb') as f:
-        assert_equal_zip(BytesIO(resp.body), f)
+        assert_equal_zip(io.BytesIO(resp.body), f)
 
     assert formdef.data_class().count() == 1
     assert formdef.data_class().select()[0].status == 'wf-st2'
@@ -866,7 +867,7 @@ def test_formdata_generated_document_to_backoffice_field(pub):
     template_filename = os.path.join(os.path.dirname(__file__), '..', 'template.odt')
     template = open(template_filename, 'rb').read()
     upload = QuixoteUpload('/foo/template.odt', content_type='application/octet-stream')
-    upload.fp = BytesIO()
+    upload.fp = io.BytesIO()
     upload.fp.write(template)
     upload.fp.seek(0)
     export_to.model_file = UploadedFile(pub.app_dir, None, upload)
@@ -911,7 +912,7 @@ def test_formdata_generated_document_to_backoffice_field(pub):
         resp = resp.follow()
         assert resp.content_type == 'application/octet-stream'
         with open(os.path.join(os.path.dirname(__file__), '..', 'template-out.odt'), 'rb') as f:
-            assert_equal_zip(BytesIO(resp.body), f)
+            assert_equal_zip(io.BytesIO(resp.body), f)
 
     assert formdef.data_class().count() == 1
     assert formdef.data_class().select()[0].status == 'wf-st2'
@@ -933,7 +934,7 @@ def test_formdata_generated_document_in_private_history(pub):
     export_to = ExportToModel()
     export_to.label = 'create doc'
     upload = QuixoteUpload('/foo/test.rtf', content_type='application/rtf')
-    upload.fp = BytesIO()
+    upload.fp = io.BytesIO()
     upload.fp.write(b'HELLO WORLD')
     upload.fp.seek(0)
     export_to.model_file = UploadedFile(pub.app_dir, None, upload)
@@ -1087,7 +1088,7 @@ def test_formdata_form_file_download(pub):
     formdata = formdef.data_class().select()[0]
     assert 'xxx_var_yyy_raw' in formdata.workflow_data
 
-    download = resp.test_app.get(urlparse.urljoin(resp.location, 'files/form-xxx-yyy/test.txt'))
+    download = resp.test_app.get(urllib.parse.urljoin(resp.location, 'files/form-xxx-yyy/test.txt'))
     assert download.content_type == 'text/plain'
     assert download.body == b'foobar'
 
@@ -1292,7 +1293,7 @@ def test_formdata_workflow_form_prefill_autocomplete(pub):
         data = {'data': [{'id': '1', 'text': 'hello', 'extra': 'foo'}]}
 
         def side_effect(url, *args):
-            return StringIO(json.dumps(data))
+            return io.StringIO(json.dumps(data))
 
         urlopen.side_effect = side_effect
 
